Find Correct Statements

Question 1 :

import java.io.*;
public class MyProgram 
{
    public static void main(String args[])
    {
        FileOutputStream out = null;
        try 
        {
            out = new FileOutputStream("test.txt");
            out.write(122);
        }
        catch(IOException io) 
        {
            System.out.println("IO Error.");
        }
        finally 
        {
            out.close();
        }
    }
}
and given that all methods of class FileOutputStream, including close(), throw an IOException, which of these is true?


A). This program will compile successfully.
B). This program fails to compile due to an error at line 4.
C). This program fails to compile due to an error at line 6.
D). This program fails to compile due to an error at line 18.
Answer : Option D

Explanation :

Any method (in this case, the main() method) that throws a checked exception (in this case, out.close() ) must be called within a try clause, or the method must declare that it throws the exception. Either main() must declare that it throws an exception, or the call to out.close() in the finally block must fall inside a (in this case nested) try-catch block.


Question 2 :

public class MyProgram 
{
    public static void throwit() 
    {
        throw new RuntimeException();
    }
    public static void main(String args[])
    {
        try 
        {
            System.out.println("Hello world ");
            throwit();
            System.out.println("Done with try block ");
        }
        finally 
        {
            System.out.println("Finally executing ");
        }
    }
}
which answer most closely indicates the behavior of the program?


A). The program will not compile.
B). The program will print Hello world, then will print that a RuntimeException has occurred, then will print Done with try block, and then will print Finally executing.
C). The program will print Hello world, then will print that a RuntimeException has occurred, and then will print Finally executing.
D). The program will print Hello world, then will print Finally executing, then will print that a RuntimeException has occurred.
Answer : Option D

Explanation :

Once the program throws a RuntimeException (in the throwit() method) that is not caught, the finally block will be executed and the program will be terminated. If a method does not handle an exception, the finally block is executed before the exception is propagated.


Question 3 :

public class ExceptionTest 
{ 
    class TestException extends Exception {} 
    public void runTest() throws TestException {} 
    public void test() /* Point X */ 
    { 
        runTest(); 
    } 
}
At Point X on line 5, which code is necessary to make the code compile?


A). No code is necessary.
B). throws Exception
C). catch ( Exception e )
D). throws RuntimeException
Answer : Option B

Explanation :

Option B is correct. This works because it DOES throw an exception if an error occurs.

Option A is wrong. If you compile the code as given the compiler will complain:

"unreported exception must be caught or declared to be thrown" The class extends Exception so we are forced to test for exceptions.

Option C is wrong. The catch statement belongs in a method body not a method specification.

Option D is wrong. TestException is a subclass of Exception therefore the test method, in this example, must throw TestException or some other class further up the Exception tree. Throwing RuntimeException is just not on as this belongs in the java.lang.RuntimeException branch (it is not a superclass of TestException). The compiler complains with the same error as in A above.


Question 4 :

System.out.print("Start ");
try 
{
    System.out.print("Hello world");
    throw new FileNotFoundException();
}
System.out.print(" Catch Here "); /* Line 7 */
catch(EOFException e) 
{
    System.out.print("End of file exception");
}
catch(FileNotFoundException e) 
{
    System.out.print("File not found");
}
and given that EOFException and FileNotFoundException are both subclasses of IOException, and further assuming this block of code is placed into a class, which statement is most true concerning this code?


A). The code will not compile.
B). Code output: Start Hello world File Not Found.
C). Code output: Start Hello world End of file exception.
D). Code output: Start Hello world Catch Here File not found.
Answer : Option A

Explanation :

Line 7 will cause a compiler error. The only legal statements after try blocks are either catch or finally statements.

Option B, C, and D are incorrect based on the program logic described above. If line 7 was removed, the code would compile and the correct answer would be Option B.


Question 5 :

Which statement is true?


A). catch(X x) can catch subclasses of X where X is a subclass of Exception.
B). The Error class is a RuntimeException.
C). Any statement that can throw an Error must be enclosed in a try block.
D). Any statement that can throw an Exception must be enclosed in a try block.
Answer : Option A

Explanation :

Option A is correct. If the class specified in the catch clause does have subclasses, any exception object that subclasses the specified class will be caught as well.
Option B is wrong. The error class is a subclass of Throwable and not Runtime Exception.
Option C is wrong. You do not catch this class of error.
Option D is wrong. An exception can be thrown to the next method higher up the call stack.


Question 6 :

Which four can be thrown using the throw statement?

1. Error
2. Event
3. Object
4. Throwable
5. Exception
6. RuntimeException


A). 1, 2, 3 and 4
B). 2, 3, 4 and 5
C). 1, 4, 5 and 6
D). 2, 4, 5 and 6
Answer : Option C

Explanation :

The (1), (4), (5) and (6) are the only four that can be thrown.

An Error is a subclass of Throwable that indicates serious problems that a reasonable application should not try to catch.

The Throwable class is the superclass of all errors and exceptions in the Java language.

The class Exception and its subclasses are a form of Throwable that indicates conditions that a reasonable application might want to catch (checked exceptions)

RuntimeException is the superclass of those exceptions that can be thrown during the normal operation of the Java Virtual Machine.


Question 7 :

Which statement is true?


A). A try statement must have at least one corresponding catch block.
B). Multiple catch statements can catch the same class of exception more than once.
C). An Error that might be thrown in a method must be declared as thrown by that method, or be handled within that method.
D). Except in case of VM shutdown, if a try block starts to execute, a corresponding finally block will always start to execute.
Answer : Option D

Explanation :

A is wrong. A try statement can exist without catch, but it must have a finally statement.

B is wrong. A try statement executes a block. If a value is thrown and the try statement has one or more catch clauses that can catch it, then control will be transferred to the first such catch clause. If that catch block completes normally, then the try statement completes normally.

C is wrong. Exceptions of type Error and RuntimeException do not have to be caught, only checked exceptions (java.lang.Exception) have to be caught. However, speaking of Exceptions, Exceptions do not have to be handled in the same method as the throw statement. They can be passed to another method.

If you put a finally block after a try and its associated catch blocks, then once execution enters the try block, the code in that finally block will definitely be executed except in the following circumstances:

An exception arising in the finally block itself.
The death of the thread.
The use of System.exit()
Turning off the power to the CPU.
I suppose the last three could be classified as VM shutdown.